' ILI9325 Driver using Dracblade P0 - P11 pins and three latches
' and also contains the dracblade ram driver for fast block moves from ram to the display
' Methods:
' .Start = start the driver
' .Draw  = start drawing at x1,y1 and continue until x2,y2
' .Pixel = a pixel in 2 bytes RRRRRGGG GGGBBBBB
OBJ  
    wait    : "timing"                                    ' thanks to parallax   

VAR
     long DisplayPins ' status of all the display pins
       
PUB Start_ILI9325
    DisplayPins := %00000000_00000000_00000000_00000000 ' store the status of the display pins
    EnableLatchPins                                     ' enable pins 0 to 11
    ResetHigh
    wait.pause1ms(5)
    ResetLow
    wait.pause1ms(5)
    ResetHigh
    ChipSelectHigh
    ReadHigh
    WriteHigh
    wait.pause1ms(5)
    ChipSelectLow
          ' ************* Start Initial Sequence **********
    Lcd_Write_Com($00,$E5)
    Lcd_Write_Data($78,$F0)                               ' set SRAM internal timing
    Lcd_Write_Com($00,$01)
    Lcd_Write_Data($01,$00)                             ' set SS and SM bit
    Lcd_Write_Com($00,$02)
    Lcd_Write_Data($07,$00)                             ' set 1 line inversion
    Lcd_Write_Com($00,$03)
    Lcd_Write_Data($10,$30)                             ' set GRAM write direction and BGR=1.
    Lcd_Write_Com($00,$04)
    Lcd_Write_Data($00,$00)                             ' Resize register
    Lcd_Write_Com($00,$08)
    Lcd_Write_Data($02,$07)                             ' set the back porch and front porch
    Lcd_Write_Com($00,$09)
    Lcd_Write_Data($00,$00)                             ' set non-display area refresh cycle ISC[3:0]
    Lcd_Write_Com($00,$0A)
    Lcd_Write_Data($00,$00)                             ' FMARK function
    Lcd_Write_Com($00,$0C)
    Lcd_Write_Data($00,$00)                             ' RGB interface setting
    Lcd_Write_Com($00,$0D)
    Lcd_Write_Data($00,$00)                             ' Frame marker Position
    Lcd_Write_Com($00,$0F)
    Lcd_Write_Data($00,$00)                             ' RGB interface polarity
'        *************Power On sequence ****************//
    Lcd_Write_Com($00,$10)
    Lcd_Write_Data($00,$00)                             ' SAP, BT[3:0], AP, DSTB, SLP, STB
    Lcd_Write_Com($00,$11)
    Lcd_Write_Data($00,$07)                             ' DC1[2:0], DC0[2:0], VC[2:0]
    Lcd_Write_Com($00,$12)
    Lcd_Write_Data($00,$00)                             ' VREG1OUT voltage
    Lcd_Write_Com($00,$13)
    Lcd_Write_Data($00,$00)                             ' VDV[4:0] for VCOM amplitude
    Lcd_Write_Com($00,$07)
    Lcd_Write_Data($00,$01)
    wait.pause1ms(50)                                  ' Dis-charge capacitor power voltage
    Lcd_Write_Com($00,$10)
    Lcd_Write_Data($10,$90)                             ' 1490//SAP, BT[3:0], AP, DSTB, SLP, STB
    Lcd_Write_Com($00,$11)
    Lcd_Write_Data($02,$27)                             ' DC1[2:0], DC0[2:0], VC[2:0]
    wait.pause1ms(50)                                  ' delay
    Lcd_Write_Com($00,$12)
    Lcd_Write_Data($00,$1F)                             '001C// Internal reference voltage= Vci;
    wait.pause1ms(50)                                  ' delay   
    Lcd_Write_Com($00,$13)
    Lcd_Write_Data($15,$00)                             '$1000//1400   Set VDV[4:0] for VCOM amplitude  1A00
    Lcd_Write_Com($00,$29)
    Lcd_Write_Data($00,$27)                             '$0012 //001a  Set VCM[5:0] for VCOMH  //$0025  0034
    Lcd_Write_Com($00,$2B)
    Lcd_Write_Data($00,$0D)                             ' Set Frame Rate   000C
    wait.pause1ms(50)                                  ' delay   
    Lcd_Write_Com($00,$20)
    Lcd_Write_Data($00,$00)                             ' GRAM horizontal Address
    Lcd_Write_Com($00,$21)
    Lcd_Write_Data($00,$00)                             ' GRAM Vertical Address
'         ----------- Adjust the Gamma Curve ----------//
    Lcd_Write_Com($00,$30)
    Lcd_Write_Data($00,$00)
    Lcd_Write_Com($00,$31)
    Lcd_Write_Data($07,$07)
    Lcd_Write_Com($00,$32)
    Lcd_Write_Data($03,$07)
    Lcd_Write_Com($00,$35)
    Lcd_Write_Data($02,$00)
    Lcd_Write_Com($00,$36)
    Lcd_Write_Data($00,$08)                           '//0207
    Lcd_Write_Com($00,$37)
    Lcd_Write_Data($00,$04)                           '//0306
    Lcd_Write_Com($00,$38)
    Lcd_Write_Data($00,$00)                           '//0102
    Lcd_Write_Com($00,$39)
    Lcd_Write_Data($07,$07)                           '//0707
    Lcd_Write_Com($00,$3C)
    Lcd_Write_Data($00,$02)                           '//0702
    Lcd_Write_Com($00,$3D)
    Lcd_Write_Data($1D,$04)                           '//1604
'        ------------------ Set GRAM area ---------------//
    Lcd_Write_Com($00,$50)
    Lcd_Write_Data($00,$00)     ' Horizontal GRAM Start Address
    Lcd_Write_Com($00,$51)
    Lcd_Write_Data($00,$EF)     ' Horizontal GRAM End Address
    Lcd_Write_Com($00,$52)
    Lcd_Write_Data($00,$00)     ' Vertical GRAM Start Address
    Lcd_Write_Com($00,$53)
    Lcd_Write_Data($01,$3F)     ' Vertical GRAM Start Address
    Lcd_Write_Com($00,$60)
    Lcd_Write_Data($A7,$00)     ' Gate Scan Line
    Lcd_Write_Com($00,$61)
    Lcd_Write_Data($00,$01)     ' NDL,VLE, REV
    Lcd_Write_Com($00,$6A)
    Lcd_Write_Data($00,$00)     ' set scrolling line
'        -------------- Partial Display Control ---------/

    Lcd_Write_Com($00,$80)
    Lcd_Write_Data($00,$00)
    Lcd_Write_Com($00,$81)
    Lcd_Write_Data($00,$00)
    Lcd_Write_Com($00,$82)
    Lcd_Write_Data($00,$00)
    Lcd_Write_Com($00,$83)
    Lcd_Write_Data($00,$00)
    Lcd_Write_Com($00,$84)
    Lcd_Write_Data($00,$00)
    Lcd_Write_Com($00,$85)
    Lcd_Write_Data($00,$00)
'        //-------------- Panel Control -------------------//
    Lcd_Write_Com($00,$90)
    Lcd_Write_Data($00,$10)
    Lcd_Write_Com($00,$92)
    Lcd_Write_Data($06,$00)
    Lcd_Write_Com($00,$07)
    Lcd_Write_Data($01,$33)     ' 262K color and display ON

    'ChipSelectHigh    ' disable talking to the board
    'ChipSelectLow     ' talk to the board , leave this always low
    TristateLatchPins                                   ' tristate pins 0-11 so other drivers can use these pins

PUB Draw(x1, y1, x2, y2)      ' sets the pixel to x1,y1 and then fills the next (x2-x1)*(y2-y1) pixels
    EnableLatchPins                                     ' enable pins 0-11
    Lcd_Write_Com($00,$20)
    Lcd_Write_Data(x1>>8,x1)
    Lcd_Write_Com($00,$21)
    Lcd_Write_Data(y1>>8,y1)
    Lcd_Write_Com($00,$50)
    Lcd_Write_Data(x1>>8,x1)
    Lcd_Write_Com($00,$52)
    Lcd_Write_Data(y1>>8,y1)
    Lcd_Write_Com($00,$51)
    Lcd_Write_Data(x2>>8,x2)
    Lcd_Write_Com($00,$53)
    Lcd_Write_Data(y2>>8,y2)
    Lcd_Write_Com($00,$22)
    TristateLatchPins                                   ' tristate pins 0-11 so other drivers can use these pins

PUB Pixel(VH,VL)               ' send out a pixel, high byte then low byte
    EnableLatchPins                                     ' enable pins 0-11    
    Lcd_Write_Data(VH,VL)  
    TristateLatchPins                                   ' tristate pins 0-11 so other drivers can use these pins               
'********************** private methods *********************
PRI LCD_Writ_Bus(VH,VL) 
    Latch5(VL)                                          ' send low byte
    Latch6(VH)                                          ' send high byte
    WriteLow                                            ' write pin low
    WriteHigh                                           ' toggle write pin

PRI Lcd_Write_Com(VH,VL)
    RSLow
    LCD_Writ_Bus(VH,VL)

PRI Lcd_Write_Data(VH,VL)
    RSHigh
    LCD_Writ_Bus(VH,VL)    

PRI EnableLatchPins
    DIRA:=%00000000_00000000_00001111_11111111 ' 138 active, gate active and 8 data lines active    
PRI TristateLatchPins ' tristate all pins - needs a pullup on the 138 enable prop pin P8
    DIRA:=%00000000_00000000_00000000_00000000     
PRI ToggleGate
   OUTA[8]:=0                                            ' set gate pin low
   OUTA[8]:=1                                            ' and high again - may need a delay in PASM

PRI Latch5(VL)                                          ' send the low byte xxxx = C,B,A,enable
   VL := VL | %00000000_00000000_00001011_00000000      ' OR with the LCD address  101
   OUTA := VL                                            ' 4 send it to propeller pins
   ToggleGate                                           ' 5 and latch it to the latch

PRI Latch6(VH)                                          ' send the middle byte 
   VH := VH | %00000000_00000000_00001101_00000000        ' 3 OR with the LCD address for latch 6  110
   OUTA := VH                                              ' 4 send it to propeller pins
   ToggleGate                                           ' 5 and latch it to the latch

PRI Latch7 | i                                          ' send the high byte if DisplayPins to the approprite latch
   i := DisplayPins                                     ' get the value                                         
   i := i >> 16                                         ' shift right by 16 places 
   i := i & %11111111                                   ' mask the low byte
   i := i | %00000000_00000000_00001111_00000000        ' 3 OR with the LCD address for latch 7    111
   OUTA := i                                            ' 4 send it to propeller pins
   ToggleGate                                           ' 5 and latch it to the latch

PRI RSLow                                    ' RS pin
    DisplayPins := DisplayPins & %11111111_11111110_11111111_11111111      ' mask the rs pin to zero 
    Latch7                                              ' send to the latch

PRI RSHigh
    DisplayPins := DisplayPins | %00000000_00000001_00000000_00000000      ' mask the rs pin to 1 
    Latch7                                              ' send to the latch

PRI WriteLow                                    
    DisplayPins := DisplayPins & %11111111_11111101_11111111_11111111      ' mask the write pin to zero 
    Latch7                                              ' send to the latch

PRI WriteHigh
    DisplayPins := DisplayPins | %00000000_00000010_00000000_00000000      ' mask the write pin to 1 
    Latch7                                              ' send to the latch

PRI ReadLow                                    
    DisplayPins := DisplayPins & %11111111_11111011_11111111_11111111      ' mask the read pin to zero 
    Latch7                                              ' send to the latch

PRI ReadHigh
    DisplayPins := DisplayPins | %00000000_00000100_00000000_00000000      ' mask the read pin to 1 
    Latch7    

PRI ChipSelectLow                                    
    DisplayPins := DisplayPins & %11111111_11110111_11111111_11111111      ' mask the cs pin to zero 
    Latch7                                              ' send to the latch

PRI ChipSelectHigh
    DisplayPins := DisplayPins | %00000000_00001000_00000000_00000000      ' mask the cs pin to 1 
    Latch7

PRI ResetLow                                    
    DisplayPins := DisplayPins & %11111111_11101111_11111111_11111111      ' mask the reset pin to zero 
    Latch7                                              ' send to the latch

PRI ResetHigh
    DisplayPins := DisplayPins | %00000000_00010000_00000000_00000000      ' mask the reset pin to 1 
    Latch7

CON
''Dracblade driver for talking to a ram chip via three latches
'' Modified code from Cluso's triblade
'' also includes commands to move blocks of data to the ILI9325 touchscreen display
' DoCmd(command_, hub_address, ram_address, block_length)
' R - read bytes at address n up (n to n+block_length) where n =0 to 65535 (ie lower 64k of the sram chip)
' W - write bytes at address n up
' I - initialise
' N - Led on
' F - Led off
' H - set high latch to value in ramaddress A16 to A23 (will include the led)
' I - move a block of data (block_length) from ram_address to the ILI9325 display (assumes Draw has been called in spin first)
' D - move a block of data (block_length) from hub_address to the ILI9325 display (assumes Draw has been called in spin first)

VAR

' communication params(5) between cog driver code - only "command" and "errx" are modified by the driver
   long  command, hubaddrs, ramaddrs, blocklen, errx, cog ' rendezvous between spin and assembly (can be used cog to cog)
'        command  = R, W, N, F H I,D =0 when operation completed by cog
'        hubaddrs = hub address for data buffer
'        ramaddrs = ram address for data ($0000 to $FFFF)
'        blocklen = ram buffer length for data transfer
'        errx     = returns =0 (false=good), else <>0 (true & error code)
'        cog      = cog no of driver (set by spin start routine)
   
PUB start_ram : err_
' Initialise the Drac Ram driver. No actual changes to ram as the read/write routines handle this
  command := "I"
  cog := 1 + cognew(@tbp2_start, @command)
  if cog == 0
    err_ := $FF                 ' error = no cog
  else
    repeat while command        ' driver cog sets =0 when done
    err_ := errx                ' driver cog sets =0 if no error, else xx = error code

PUB stop_ram
   if cog
      cogstop(cog~ - 1)      

PUB DoCmd(command_, hub_address, ram_address, block_length) : err_
' Do the command: R, W, N, F, H,I,D
  hubaddrs := hub_address       ' hub address start
  ramaddrs := ram_address       ' ram address start
  blocklen := block_length      ' block length
  command  := command_          ' must be last !!
' Wait for command to complete and get status
  repeat while command          ' driver cog sets =0 when done
  err_ := errx                  ' driver cog sets =0 if no error, else xx = error code


DAT
'' +--------------------------------------------------------------------------+
'' | Dracblade Ram Driver (with grateful acknowlegements to Cluso)            |
'' +--------------------------------------------------------------------------+
                        org     0
tbp2_start    ' setup the pointers to the hub command interface (saves execution time later
                                      '  +-- These instructions are overwritten as variables after start
comptr                  mov     comptr, par     ' -|  hub pointer to command                
hubptr                  mov     hubptr, par     '  |  hub pointer to hub address            
ramptr                  add     hubptr, #4      '  |  hub pointer to ram address            
lenptr                  mov     ramptr, par     '  |  hub pointer to length                 
errptr                  add     ramptr, #8      '  |  hub pointer to error status           
cmd                     mov     lenptr, par     '  |  command  I/R/W/G/P/Q                  
hubaddr                 add     lenptr, #12     '  |  hub address                           
ramaddr                 mov     errptr, par     '  |  ram address                           
len                     add     errptr, #16     '  |  length                                
err                     nop                     ' -+  error status returned (=0=false=good) 


' Initialise hardware (unlike the triblade, just tristates everything and read/write set the pins)
init                    mov     err, #0                  ' reset err=false=good
                        mov     dira,zero                ' tristate the pins

done                    wrlong  err, errptr             ' status  =0=false=good, else error x
                        wrlong  zero, comptr            ' command =0 (done)
' wait for a command (pause short time to reduce power)
pause                   mov     ctr, delay      wz      ' if =0 no pause
              if_nz     add     ctr, cnt
              if_nz     waitcnt ctr, #0                 ' wait for a short time (reduces power)
                        rdlong  cmd, comptr     wz      ' command ?
              if_z      jmp     #pause                  ' not yet
' decode command
                        cmp     cmd, #"R"       wz      ' R = read block
              if_z      jmp     #rdblock
                        cmp     cmd, #"W"       wz      ' W = write block
              if_z      jmp     #wrblock
                        cmp     cmd, #"N"       wz      ' N= led on
              if_z      jmp     #led_turn_on
                        cmp     cmd, #"F"       wz      ' F = led off
              if_z      jmp     #led_turn_off
                        cmp     cmd, #"H"       wz      ' H sets the high latch
              if_z      jmp     #sethighlatch
                        cmp     cmd, #"I"       wz      ' I moves a block of data from ram to the display
              if_z      jmp     #extramtodisplay
                        cmp     cmd, #"D"       wz      ' D moves a block of data from hub to the display
              if_z      jmp     #hubtodisplay      
                        mov     err, cmd                ' error = cmd (unknown command)
                        jmp     #done


tristate                mov     dira,zero                ' all inputs to zero
                        jmp     #done

' turn led on
led_turn_on             or      HighLatch,ledpin        ' set the led pin high
                        jmp     #OutputHighLatch         ' send this out

led_turn_off            andn    HighLatch,ledpin        ' set the led pin low
                        jmp     #OutputHighLatch         ' send this out

' set high address bytes with command H, pass value in third variable of the DoCmd
' 4 bytes - masks off all but bits 16 to 23

sethighlatch            call #ram_open                  ' gets address value in 'address'
                        shr  address,#16                ' shift right by 16 places
                        and  address,#$FF               ' ensure rest of bits zero
                        mov  HighLatch,address          ' put value into HighLatch
                        jmp  #OutputHighLatch           ' and output it

'---------------------------------------------------------------------------------------------------------
'Memory Access Functions

rdblock                 call    #ram_open               ' get variables from hub variables
rdloop                  call    #read_memory_byte       ' read byte from address into data_8
                        wrbyte  data_8,hubaddr          ' write data_8 to hubaddr ie copy byte to hub
                        add     hubaddr,#1              ' add 1 to hub address
                        add     address,#1              ' add 1 to ram address
                        djnz    len,#rdloop             ' loop until done
                        jmp     #init                   ' reinitialise

wrblock                 call    #ram_open                        
wrloop                  rdbyte  data_8, hubaddr         ' copy byte from hub
                        call    #write_memory_byte      ' write byte from data_8 to address
                        add     hubaddr,#1              ' add 1 to hub address
                        add     address,#1              ' add 1 to ram address
                        djnz    len,#wrloop             ' loop until done
                        jmp     #init                   ' reinitialise

ram_open                rdlong  hubaddr, hubptr         ' get hub address
                        rdlong  ramaddr, ramptr         ' get ram address
                        rdlong  len, lenptr             ' get length
                        mov     err, #5                 ' err=5
                        mov     address,ramaddr         ' cluso's variable 'ramaddr' to dracblade variable 'address'
ram_open_ret            ret
  
read_memory_byte        call #RamAddress                ' sets up the latches with the correct ram address
                        mov dira,LatchDirection2        ' for reads so P0-P7 tristate till do read
                        mov outa,GateHigh               ' actually ReadEnable but they are the same
                        andn outa,GateHigh              ' set gate low
                        nop                             ' short delay to stabilise
                        nop
                        mov data_8, ina                 ' read SRAM
                        and data_8, #$FF                ' extract 8 bits
                        or  outa,GateHigh               ' set the gate high again
read_memory_byte_ret    ret

write_memory_byte       call #RamAddress                ' sets up the latches with the correct ram address
                        mov outx,data_8                 ' get the byte to output
                        and outx, #$FF                  ' ensure upper bytes=0
                        or outx,WriteEnable             ' or with correct 138 address
                        mov outa,outx                   ' send it out
                        andn outa,GateHigh              ' set gate low
                        nop                             ' no nop doesn't work, one does, so put in two to be sure
                        nop                             ' another NOP
                        or outa,GateHigh                ' set it high again
write_memory_byte_ret   ret

RamAddress ' sets up the ram latches. Assumes high latch A16-A18 low so only accesses 64k of ram
                        mov dira,LatchDirection         ' set up the pins for programming latch chips
                        mov outx,address                ' get the address into a temp variable
                        and outx,#$FF                   ' mask the low byte
                        or  outx,LowAddress             ' or with 138 low address
                        mov outa,outx                   ' send it out
                        andn outa,GateHigh              ' set gate low
                                                        ' ?? a NOP
                        or outa,GateHigh                ' set it high again  
                                                        ' now repeat for the middle byte     
                        mov outx,address                ' get the address into a temp variable
                        shr outx,#8                     ' shift right by 8 places
                        and outx,#$FF                   ' mask the low byte
                        or  outx,MiddleAddress          ' or with 138 middle address
                        mov outa,outx                   ' send it out
                        andn outa,GateHigh              ' set gate low
                        or outa,GateHigh                ' set it high again 
RamAddress_ret          ret

OutputHighLatch ' sends out HighLatch to the 374 that does A16-19, led and the 4 spare outputs
                        mov     dira,latchdirection     ' setup active pins 138 and bus
                        mov     outa,HighLatch          ' send out HighLatch
                        or      outa,HighAddress        ' or with the high address
                        andn    outa,GateHigh           ' set gate low
                        or      outa,GateHigh           ' set the gate high again
OutputHighLatch_ret     jmp     #tristate               ' set pins tristate


extramtodisplay ' send a block of data blocklen from external memory ramaddress to the ILI9325 display
                        call    #ram_open ' gets address and len (ignore hubaddress)
                        shr     len,#1                  ' len /2 as 2 bytes per pixel   
                        mov     dira,latchdirection     ' enable for output
                        mov     outa,latch7data         ' sets CS low, RS high (RS high is data output
                        andn    outa,GateHigh           ' set gate low
                        or      outa,GateHigh           ' set it high again 
ililoop                 call    #read_memory_byte       ' read byte from address into data_8
                        mov     dira,latchdirection     ' enable for output (readmemorybyte leaves P0-P7 as inputs) 
                        or      data_8,Latch6address    ' or with the latch6 address
                        mov     outa,data_8             ' send it out
                        andn    outa,GateHigh           ' set gate low
                        or      outa,GateHigh           ' set it high again
                        add     address,#1              ' add 1 to ram address 
                        
                        call    #read_memory_byte       ' read second byte from address into data_8
                        mov     dira,latchdirection     ' enable for output (readmemorybyte leaves P0-P7 as inputs) 
                        or      data_8,latch5address    ' or with the latch5 address
                        mov     outa,data_8             ' send it out
                        andn    outa,GateHigh           ' set gate low
                        or      outa,GateHigh           ' set it high again
                        add     address,#1              ' add 1 to ram address
                        call    #toggledisplaywrite
                        djnz    len,#ililoop            ' loop until done
                        jmp     #tristate               ' set pins to tristate

toggledisplaywrite      mov     outa,latch7writelow     ' set the write pin low
                        andn    outa,GateHigh           ' set gate low
                        or      outa,GateHigh           ' set it high again

                        mov     outa,latch7data         ' set the write pin high
                        andn    outa,GateHigh           ' set gate low
                        or      outa,GateHigh           ' set it high again
toggledisplaywrite_ret  ret                                                

hubtodisplay            ' send a block of data blocklen from hubaddr to the display (bypasses external ram)
                        call    #ram_open ' gets hubaddr and len (ignores ramaddress)
                        shr     len,#1                  ' len /2 as 2 bytes per pixel
                        mov     dira,latchdirection     ' enable for output
                        mov     outa,latch7data         ' sets CS low, RS high (RS high is data output
                        andn    outa,GateHigh           ' set gate low
                        or      outa,GateHigh           ' set it high again 
hubdisploop             rdbyte  data_8, hubaddr         ' copy byte from hub
                        or      data_8,Latch6address    ' or with the latch5 address
                        mov     outa,data_8             ' send it out
                        andn    outa,GateHigh           ' set gate low
                        or      outa,GateHigh           ' set it high again
                        add     hubaddr,#1              ' add 1 to hub address

                        rdbyte  data_8, hubaddr         ' copy byte from hub  
                        or      data_8,latch5address    ' or with the latch5 address
                        mov     outa,data_8             ' send it out
                        andn    outa,GateHigh           ' set gate low
                        or      outa,GateHigh           ' set it high again           
                        add     hubaddr,#1              ' add 1 to hub address

                        call    #toggledisplaywrite  
                        djnz    len,#hubdisploop        ' loop until done
                        jmp     #tristate               ' set pins to tristate
                                                



delay                   long    80                                    ' waitcnt delay to reduce power (#80 = 1uS approx)
ctr                     long    0                                     ' used to pause execution (lower power use) & byte counter
GateHigh                long    %00000000_00000000_00000001_00000000  ' HC138 gate high, all others must be low
Outx                    long    0                                     ' for temp use, same as n in the spin code
LatchDirection          long    %00000000_00000000_00001111_11111111 ' 138 active, gate active and 8 data lines active
LatchDirection2         long    %00000000_00000000_00001111_00000000 ' for reads so data lines are tristate till the read
LowAddress              long    %00000000_00000000_00000101_00000000 ' low address latch = xxxx010x and gate high xxxxxxx1
MiddleAddress           long    %00000000_00000000_00000111_00000000 ' middle address latch = xxxx011x and gate high xxxxxxx1
HighAddress             long    %00000000_00000000_00001001_00000000 ' high address latch = xxxx100x and gate high xxxxxxx1
'ReadEnable long    %00000000_00000000_00000001_00000000 ' /RD = xxxx000x and gate high xxxxxxx1
                                                        ' commented out as the same as GateHigh
WriteEnable             long    %00000000_00000000_00000011_00000000 ' /WE = xxxx001x and gate high xxxxxxx1
Zero                    long    %00000000_00000000_00000000_00000000 ' for tristating all pins
data_8                  long    %00000000_00000000_00000000_00000000 ' so code compatability with zicog driver
address                 long    %00000000_00000000_00000000_00000000 ' address for ram chip
ledpin                  long    %00000000_00000000_00000000_00001000 ' to turn on led
HighLatch               long    %00000000_00000000_00000000_00000000 ' static value for the 374 latch that does the led, hA16-A19 and the other 4 outputs
' variables and constants for the ILI9325 display
Latch5address           long    %00000000_00000000_00001011_00000000 ' latch5 address
Latch6address           long    %00000000_00000000_00001101_00000000 ' latch6 address
Latch7data              long    %00000000_00000000_00001111_00010111 ' latch7 address 111x and gate high, reset high, cs low, read high, write high, rs high for data output, combines rshigh in spin into one line                   
Latch7WriteLow          long    %00000000_00000000_00001111_00010101 ' cs low, write low
                        fit     496      